﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.IO;

namespace reflection
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            myControl.UC = this;
            myControl.SetUC();
            var N = Convert.ToInt32(TextBox1.Text);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.WindowState = WindowState.Minimized;
            this.WindowState = WindowState.Normal;
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            myControl.SetUC();
            myControl.CalExe();
        }

        private void MenuItem2_Click(object sender, RoutedEventArgs e)
        {
            int i; int j;
            int N = Convert.ToInt32(TextBox1.Text);

            String OutText = "reflection\r\n";
            OutText = OutText + "項目\t記号\t値\t単位\r\n";
            OutText = OutText + "角度分割数\tN\t" + TextBox1.Text + "\t分割\r\n";
            OutText = OutText + "入射側屈折率実数部\tN0r\t" + TextBox2.Text + "\t無次元\r\n";
            OutText = OutText + "入射側屈折率虚数部\tN0i\t" + TextBox3.Text + "\t無次元\r\n";
            OutText = OutText + "物体側屈折率実数部\tN1r\t" + TextBox4.Text + "\t無次元\r\n";
            OutText = OutText + "物体側屈折率虚数部\tN1i\t" + TextBox5.Text + "\t無次元\r\n\r\n";

            OutText = OutText + "入射角度\tP偏光の反射率\tS偏光の反射率\r\n";
            OutText = OutText + "The0\tRp\tRs\r\n";
            OutText = OutText + "度\t無次元\t無次元\r\n";

            for (i = 0; i <= N; i++)
            {
                for (j = 0; j < 3; j++)
                {
                    OutText = OutText + myControl.dataGridView1.Rows[2 + i].Cells[j].Value + "\t";
                }
                OutText = OutText + "\r\n";
            }

            if (myControl.saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                using (StreamWriter outfile = new StreamWriter(myControl.saveFileDialog1.FileName))
                {
                    outfile.Write(OutText);
                }
            }
        }

        private void Button2_Click(object sender, RoutedEventArgs e)
        {
            var win = new Window1();

            var N = Convert.ToInt32(TextBox1.Text);
            myGraph myG = new myGraph();
            myG.SetMyC();
            int n0 =3; int n1 = N;
            double[,] array = new double[n0, n1+1];

            int i; int j;
            for (i = 0; i < n0; i++)
            {
                for (j = 0; j <= N; j++)
                {
                    array[i, j] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + j].Cells[i].Value);
                }
            }
            myG.normaliz(array);
            myG.graph(array, win.Grid2);


            win.Show();
            this.Close();
        }
    }


    public class myGraph
    {
        public Color[] c = new Color[18];
        public void SetMyC()
        {
            int i;
            for (i = 0; i < 2; i++)
            {
                c[i + 1] = Color.FromArgb(255, Convert.ToByte(255 - 75 * i), 0, 0);
                c[i + 3] = Color.FromArgb(255, 0, Convert.ToByte(255 - 75 * i), 0);
                c[i + 5] = Color.FromArgb(255, 0, 0, Convert.ToByte(255 - 75 * i));
            }
            c[0] = Color.FromArgb(255, 0, 0, 0);
        }



        public void normaliz(double[,] array)
        {
            int n0 = array.GetUpperBound(0) + 1;
            int n1 = array.GetUpperBound(1) + 1;
            double[] max = new double[n0];
            double[] min = new double[n0];
            int i; int j;


            max[2] = -1e12;
            min[2] = 1e12;
            for (j = 0; j < n1; j++)
            {
                if (array[0, j] < min[2]) { min[2] = array[0, j]; }
                if (array[0, j] > max[2]) { max[2] = array[0, j]; }
            }
            for (j = 0; j < n1; j++)
            {
                array[0, j] = (array[0, j] - min[2]) / (max[2] - min[2]);
            }

        }

        public void graph(double[,] array, Grid Grid1)
        {
            int n0 = array.GetUpperBound(0) + 1;
            int n1 = array.GetUpperBound(1) + 1;

            Grid1.Children.Clear();
            double x0 = 50; double y0 = 350;
            int i; int j;
            for (i = 1; i < n0; i++)
            {
                PathFigure myPathFigure = new PathFigure();
                myPathFigure.StartPoint = new Point(x0, y0);
                System.Windows.Shapes.Path myPath = new System.Windows.Shapes.Path();
                myPath.Stroke = new SolidColorBrush(c[i - 1]);
                myPath.StrokeThickness = 2;
                for (j = 0; j < n1; j++)
                {
                    myPathFigure.Segments.Add(new LineSegment(new Point(x0 + 400 * array[0, j], y0 - 300 * array[i, j]), true));
                }
                PathGeometry myPathGeometry = new PathGeometry();
                myPathGeometry.Figures.Add(myPathFigure);
                myPath.Data = myPathGeometry;
                Grid1.Children.Add(myPath);
            }
        }
    }

    
}
