﻿using System;
using System.Windows.Forms;
using System.Numerics;

namespace reflection
{
    public partial class UserControl1 : UserControl
    {
        public MainWindow UC;
        public UserControl1()
        {
            InitializeComponent();
        }

        public void SetUC()
        {
            int N = Convert.ToInt32(UC.TextBox1.Text);
            dataGridView1.RowCount =  N +  4;
            dataGridView1.Rows[0].Cells[0].Value = "The0";
            dataGridView1.Rows[0].Cells[1].Value = "Rp";
            dataGridView1.Rows[0].Cells[2].Value = "Rs";


            dataGridView1.Rows[1].Cells[0].Value = "度";
            dataGridView1.Rows[1].Cells[1].Value = "無次元";
            dataGridView1.Rows[1].Cells[2].Value = "無次元";


            int i;
            for (i = 0; i <= N; i++) { dataGridView1.Rows[2 + i].Cells[0].Value = Convert.ToString(i); }
        }

        public void CalExe()
        {
            int N = Convert.ToInt32(UC.TextBox1.Text);
            double N0r = Convert.ToDouble(UC.TextBox2.Text);
            double N0i = Convert.ToDouble(UC.TextBox3.Text);
            double N1r = Convert.ToDouble(UC.TextBox4.Text);
            double N1i = Convert.ToDouble(UC.TextBox5.Text);

            int i;
            for (i = 0; i <= N; i++)
            {
                Complex The0 = new Complex(Math.PI * i / (2 * N), 0);
                Complex N0 = new Complex(N0r, N0i);
                Complex N1 = new Complex(N1r, N1i);
                Complex A = Complex.Divide(N0, N1);
                Complex S0 = Complex.Sin(The0);

                Complex B = Complex.Multiply(A, S0);
                Complex The1 = Complex.Asin(B);
                Complex C0 = Complex.Cos(The0);
                Complex C1 = Complex.Cos(The1);
                Complex D01 = Complex.Multiply(N0, C1);
                Complex D10 = Complex.Multiply(N1, C0);
                Complex D00 = Complex.Multiply(N0, C0);
                Complex D11 = Complex.Multiply(N1, C1);
                Complex EA = Complex.Add(D01, D10);
                Complex EB = Complex.Subtract(D01, D10);
                Complex FA = Complex.Add(D00, D11);
                Complex FB = Complex.Subtract(D00, D11);

                Complex P = Complex.Divide(EB, EA);
                Complex S = Complex.Divide(FB, FA);
                double Rp = P.Magnitude * P.Magnitude;
                double Rs = S.Magnitude * S.Magnitude;

                dataGridView1.Rows[2 + i].Cells[0].Value = Convert.ToString(90*i/N);
                dataGridView1.Rows[2 + i].Cells[1].Value = Convert.ToString(Rp);
                dataGridView1.Rows[2 + i].Cells[2].Value = Convert.ToString(Rs);
            }
        }


    }
}
